<template>
	<div id="profile-options" class="lightestazure-color">
	
		<div class="options-panel row-padding">
			<div class="main-column row-padding flex">
				<div class="options columns-6 row-padding col-padding azure-gradient">
					<div class="text hustle medium">{{getLocale('options')}}</div>
					
					<div class="option-wrapper flex">
						<input id="hide-notification" type="checkbox" v-on:change="setOption('hide_notification', $event)" :checked="options.hide_notification">
						<label for="hide-notification">{{getLocale('option_hide_notification')}}</label>
					</div>
					
					<div class="option-wrapper flex">
						<input id="hide-vairus-popup" type="checkbox" v-on:change="setOption('hide_vairus_popup', $event)" :checked="options.hide_vairus_popup">
						<label for="hide-vairus-popup">{{getLocale('option_hide_vairus_popup')}}</label>
					</div>
					
					<div class="option-wrapper flex">
						<input id="hide-completed-matrix" type="checkbox" v-on:change="setOption('hide_completed_matrix', $event)" :checked="options.hide_completed_matrix">
						<label for="hide-completed-matrix">{{getLocale('option_hide_completed_matrix')}}</label>
					</div>
					
					<div class="option-wrapper flex">
						<input id="show-potential" type="checkbox" v-on:change="setOption('show_potential', $event)" :checked="options.show_potential">
						<label for="show-potential">{{getLocale('option_show_potential')}}</label>
					</div>
					
					<div class="option-wrapper flex">
						<input id="advanced-animations" type="checkbox" v-on:change="setOption('advanced_animations', $event)" :checked="options.advanced_animations">
						<label for="advanced-animations">{{getLocale('option_advanced_animations')}}</label>
					</div>
					
					<br><br>
					
					<div class="actions flex space">
						<v-button
							@clicked="refreshUserdata"
							:disabled="refreshing"
							color="lightestazure"
							:text="getLocale('refresh')"
						/>
						
						<v-button
							@clicked="credits = true"
							color="lightestazure"
							:text="getLocale('credits')"
						/>
					</div>
				</div>
			
				<div class="send-feedback columns-6 row-padding col-padding azure-gradient">
					<div class="text hustle medium">{{getLocale('send_feedback')}}</div>
					
					<div class="form">
						<div class="input-wrapper">
							<label for="feedback_title">{{getLocale('title')}}</label>
							<input id="feedback_title" type="text" maxlength="255" v-model="feedback_title" v-on:keydown="feedback_response = false"/>
						</div>	
						
						<div class="input-wrapper">
							<label for="feedback_text">{{getLocale('description')}}</label>
							<textarea id="feedback_text" maxlength="1000" v-model="feedback_text" v-on:keydown="feedback_response = false"></textarea>
						</div>	
						
						<div class="response medium-font" v-if="feedback_response">{{getLocale('thanks_feedback')}}</div>
						
						<v-button
							@clicked="sendFeedback"
							color="lightestazure"
							:text="getLocale('send')"
						/>
					</div>	
				</div>
			</div>
		</div>
		
		<transition name="fade">
			<div class="credits-modal" v-if="credits">
				<div class="backdrop" v-on:click.self="credits = false"></div>
				
				<div class="main-column" v-on:click.self="credits = false">	
					<div class="wrapper columns-4 center azure-gradient">	
						<div class="header flex space">
							<div class="hustle medium">{{getLocale('credits')}}</div>
							
							<close-icon class="close-button" color="#B3EDFF	" @clicked="credits = false"/>
						</div>
						
						<div class="contents medium-font">
							<div class="row-padding">
								<a class="flex space">Darwen<div>Developer</div></a>
								<a class="flex space" target="_blank" href="https://www.instagram.com/aira.illustration/">Aira<div>Illustrations</div></a>
								<a class="flex space">Arn<div>Graphic Design</div></a>
							</div>
						</div>
					</div>
				</div>
			</div>
		</transition>
	</div>
</template>


<script>
	var browser = browser || chrome;
	import VButton from '../components/VButton.vue';
	import CloseIcon from '../components/CloseIcon.vue';
	import { commonMixin } from '../mixins/common.js';
	import { storeGettersMixin } from '../mixins/store_getters.js';

	export default {
		props: [],
		data: function () {
			return{
				feedback_title : '',
				feedback_text : '',
				feedback_response : false,
				refreshing : false,
				credits : false
			}
		},
		methods: {
			refreshUserdata(){
				//Request the data from the backgrpound script
				this.refreshing = true;
				
				browser.runtime.sendMessage({ type : 'refresh_userdata' });
				
				setTimeout(function(){
					this.refreshing = false;
				}.bind(this), 5000);
			},
			setOption(option, e){
				browser.runtime.sendMessage({ type : 'set_option', data : {
					option : option,
					value : e.target.checked
				}});
			},
			sendFeedback(){
				if(this.feedback_text != ''){
					var data = {
						title : this.feedback_title,
						text : this.feedback_text,
						user_agent : navigator.userAgent
					}
					
					browser.runtime.sendMessage({ type : 'send_feedback', data : data });
					
					this.feedback_title = '';
					this.feedback_text = '';
					this.feedback_response = true;
				}
			}
		},
		mixins: [commonMixin, storeGettersMixin],
		components: {
			VButton, CloseIcon
		}
	}
</script>


<style lang="scss" scoped>
	@import "../styles/variables";

	#profile-options{
		position: relative;
		
		.credits-modal{
			position: fixed;
			top: 0;
			left: 0;
			bottom: 0;
			right: 0;
			z-index: 5;
			
			.backdrop{
				position: absolute;
				top: 0;
				left: 0;
				bottom: 0;
				right: 0;
				background-color: rgba(0, 0, 0, 0.7);
			}
			
			.main-column{
				height: 100%;
			}
			
			.wrapper{
				position: absolute;
				top: 50%;
				left: 50%;
				transform: translate(-50%, -50%);
				border-radius: 10px;
				padding: 20px;
				min-width: 300px;
				
				a{
					color: inherit;
					text-decoration: none;
				}
			}
		}
	
		.options{
			margin-right: 25px;
			border-radius: 10px;
			
			.text{
				margin-bottom: 20px;
			}
		
			.option-wrapper{
				padding: 10px 0;
				
				input{
					margin-right: 10px;
					width: 20px;
					cursor: pointer;
				}
				
				label{
					cursor: pointer;
				}
			}
			
			.actions{
				position: absolute;
				left: 20px;
				right: 20px;
				bottom: 20px;
			}
		}
	
		.send-feedback{
			border-radius: 10px;
			
			.text{
				margin-bottom: 20px;
			}
		
			.input-wrapper{
				margin-top: 10px;
					
				label{
					display: block;
					margin-bottom: 10px;
				}
				input{
					width: 100%;
				}
				textarea{
					width: 100%;
					height: 100px;
				}
			}
			
			.response{
				margin-top: 20px;
				padding: 5px;
				width: 300px;
			}
			
			.button{
				margin-top: 20px;
			}
		}
	}
	
	@media screen and (max-width: 768px) {
		#profile-options .main-column{
			display: block;
			
			.options, .send-feedback{
				width: 100%;
				margin-bottom: 25px;
			}
		}
	}
</style>
